import { DependencyContainer } from "./DependencyContainer";
import { nameof } from "ts-simple-nameof";
import { LocalStorageService } from "./Services/LocalStorageService";
import { ExalusConnectionService } from './ExalusConnectionService';
import { WebApiCacheService } from "./Services/WebApi/WebApiCacheService";
import { UsersService } from "./Services/Users/UsersService";
import { DevicesService } from "./Services/Devices/DevicesService";
var Api = (function () {
    function Api() {
    }
    Api.Init = function () {
        var _a;
        if (DependencyContainer.IsInitialized)
            return;
        var dep = DependencyContainer.Instance;
        (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Log(Api, "Initializing ExalusHome integration");
        try {
            dep.RegisterService(new LocalStorageService());
            dep.RegisterService(new WebApiCacheService());
            dep.RegisterService(new ExalusConnectionService());
            dep.RegisterService(new UsersService());
            dep.RegisterService(new DevicesService());
        }
        catch (ex) {
            console.error(ex);
        }
    };
    Api.GetAsync = function (classType, cancelationToken) {
        var _a;
        (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Log(Api, "[DI] [API] Get<".concat(nameof(classType), ">"));
        return DependencyContainer.Instance.GetServiceAsync(classType, cancelationToken);
    };
    Api.GetWithTimeoutAsync = function (classType, timeout) {
        var _a;
        (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Log(Api, "[DI] [API] Get<".concat(nameof(classType), ">"));
        return DependencyContainer.Instance.GetServiceWithTimeoutAsync(classType, timeout);
    };
    Api.Get = function (classType) {
        var _a;
        (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Log(Api, "[DI] [API] Get<".concat(nameof(classType), ">"));
        return DependencyContainer.Instance.GetService(classType);
    };
    Api.Version = 1.0;
    return Api;
}());
export { Api };
//# sourceMappingURL=Api.js.map