import { IDataFrame } from "./DataFrame";
import { ConnectionResult, IExalusConnectionService, AuthorizationInfo, ConnectionState } from "./IExalusConnector";
import { ITypedEvent } from "./TypedEvent";
export declare class ExalusConnectionService implements IExalusConnectionService {
    private _connection?;
    private _defaultPacketsBrokerAddress?;
    private _serversBrokerAddress?;
    private _address?;
    private _serialId?;
    private _PIN?;
    private readonly _timeout;
    private _dataReceivedEvent;
    private _pongReceivedEvent;
    private _authorizationReceivedEvent;
    private _registrationReceivedEvent;
    private _connectionStateChangedEvent;
    private _errorOccuredEvent;
    private _log;
    private InitializeConnection;
    GetServiceName(): string;
    SetServersBrokerAddress(address: string): void;
    SetDefaultPacketsBrokerAddress(address: string): void;
    GetServerAddressAsync(): Promise<[IsAddressKnown: boolean, ServerUri: string]>;
    ConnectAsync(address: string): Promise<ConnectionResult>;
    AuthorizeAsync(authorizationInfo: AuthorizationInfo): Promise<boolean>;
    ConnectAndAuthorizeAsync(authorizationInfo: AuthorizationInfo): Promise<ConnectionResult>;
    private connectAsync;
    DisconnectAsync(): Promise<void>;
    IsConnected(): boolean;
    SendAndWaitForResponseAsync<T>(dataFrame: IDataFrame<any>, timeout: number, useCache: boolean): Promise<IDataFrame<T>>;
    SendAsync(dataFrame: IDataFrame<any>): Promise<boolean>;
    OnDataReceivedEvent(): ITypedEvent<any>;
    OnConnectionStateChangedEvent(): ITypedEvent<ConnectionState>;
    OnErrorOccuredEvent(): ITypedEvent<[sender: string, data: string]>;
}
